package com.clustercontrol.cloud.util;

import com.clustercontrol.cloud.CloudManagerFault;
import com.clustercontrol.cloud.ICloudContext;
import com.clustercontrol.cloud.SessionService;
import com.clustercontrol.cloud.factory.IResourceOperatorBase;
import com.clustercontrol.cloud.registry.ObjectRegistryService;

public class ResourceUtil {
	private ResourceUtil() {
	}

	public static <T extends IResourceOperatorBase> T getResourceOperator(Class<T> clazz) throws CloudManagerFault {
		T operator = ObjectRegistryService.registry().get(clazz);
		ICloudContext context = SessionService.current().get(ICloudContext.class);
		operator.setAccessDestination(context.getAccessDestionation());
		operator.setCloudRegion(context.getCurrentRegion());
		return operator;
	}
}
