package com.clustercontrol.cloud.persistence;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;

public abstract class AbstractProcessor<A extends Annotation> implements Processor<A> {
	protected A annotation;
	protected Method getMethod;
	protected Method setMethod;
	
	@Override
	public void init(A annotation, Method getMethod, Method setMethod) {
		this.annotation = annotation;
		this.getMethod = getMethod;
		this.setMethod = setMethod;
	}

	@Override
	public void postLoad(Object entity) throws Exception {
	}

	@Override
	public void prePersist(Object entity) throws Exception {
	}

	@Override
	public void postPersist(Object entity) throws Exception {
	}

	@Override
	public void preUpdate(Object entity) throws Exception {
	}

	@Override
	public void postUpdate(Object entity) throws Exception {
	}
}
